﻿!mod$ v1 sum:4a83163dc797098c
!need$ 795922591f89c8ee n ln_precision
!need$ be7bdec2927ffebb n ln_constants
!need$ a4c9f58c4a90e7d5 n inversions
module complexbands
use ln_precision,only:sp
use ln_precision,only:dp
use ln_precision,only:eps
use ln_precision,only:eps10
use ln_precision,only:eps12
use ln_precision,only:eps15
use ln_precision,only:sgfacc
use ln_precision,only:long
use ln_precision,only:get_machine_prec
use ln_precision,only:set_drop
use ln_constants,only:j
use ln_constants,only:pi
use ln_constants,only:hh
use ln_constants,only:ee
use ln_constants,only:a0
use ln_constants,only:eovh
use ln_constants,only:kb
use ln_constants,only:oneovh
use ln_constants,only:har
use ln_constants,only:atu
use ln_constants,only:aa_bohr
use ln_constants,only:e2
use ln_constants,only:j_ev
use ln_constants,only:g0
use ln_constants,only:go
use ln_constants,only:delta_sq
use ln_constants,only:delta_w
use ln_constants,only:delta_mingo
use ln_constants,only:units
use ln_constants,only:nlengthunits
use ln_constants,only:lengthunits
use ln_constants,only:nenergyunits
use ln_constants,only:energyunits
use ln_constants,only:ncurrentunits
use ln_constants,only:currentunits
use ln_constants,only:nheatcurrentunits
use ln_constants,only:heatcurrentunits
use ln_constants,only:nheatcondunits
use ln_constants,only:heatcondunits
use ln_constants,only:convertunits
use ln_constants,only:convertcurrent
use ln_constants,only:convertheatcurrent
use ln_constants,only:convertheatconductance
use inversions,only:compgreen
use inversions,only:inverse
use inversions,only:zinv_lapack
use inversions,only:block2green
use inversions,only:block3green
use inversions,only:zlin
private::sp
private::dp
private::eps
private::eps10
private::eps12
private::eps15
private::sgfacc
private::long
private::get_machine_prec
private::set_drop
private::j
private::pi
private::hh
private::ee
private::a0
private::eovh
private::kb
private::oneovh
private::har
private::atu
private::aa_bohr
private::e2
private::j_ev
private::g0
private::go
private::delta_sq
private::delta_w
private::delta_mingo
private::units
private::nlengthunits
private::lengthunits
private::nenergyunits
private::energyunits
private::ncurrentunits
private::currentunits
private::nheatcurrentunits
private::heatcurrentunits
private::nheatcondunits
private::heatcondunits
private::convertunits
private::convertcurrent
private::convertheatcurrent
private::convertheatconductance
private::compgreen
private::inverse
private::zinv_lapack
private::block2green
private::block3green
private::zlin
real(8),parameter,private::maxk=1.2e1_8
real(8),parameter,private::nulk=1.5e1_8
type::tcomplexbandpar
integer(4)::at_start
integer(4)::at_end
integer(4)::mat_start
integer(4)::mat_end
real(8)::l
real(8)::emin
real(8)::emax
real(8)::estep
integer(4)::gw
end type
type::tstatessummary
integer(4)::prop_in
integer(4)::prop_out
integer(4)::evan_in
integer(4)::evan_out
integer(4)::null_in
integer(4)::null_out
end type
private::diagonalize
contains
subroutine compute_bands(hh,ss,par)
complex(8)::hh(:,:)
complex(8)::ss(:,:)
type(tcomplexbandpar)::par
end
subroutine complex_k(e,pldim,z11,z12,kz,z21,cl,cr,vf)
real(8),intent(in)::e
integer(4),intent(in)::pldim
complex(8)::z11(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8)::z12(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8)::kz(1_8:int(2_4*pldim,kind=8))
complex(8),optional::z21(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8),optional::cl(1_8:int(2_4*pldim,kind=8),1_8:int(2_4*pldim,kind=8))
complex(8),optional::cr(1_8:int(2_4*pldim,kind=8),1_8:int(2_4*pldim,kind=8))
real(8),optional::vf(1_8:int(2_4*pldim,kind=8))
end
subroutine states_at_k(kk,pldim,hm,sm,tm,st,ev,cr)
complex(8),intent(in)::kk
integer(4),intent(in)::pldim
complex(8)::hm(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8)::sm(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8)::tm(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8)::st(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
real(8)::ev(1_8:int(pldim,kind=8))
complex(8),optional::cr(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
end
subroutine band_velocities(kk,pldim,tm,st,ev0,cn,vf1)
real(8),intent(in)::kk
integer(4),intent(in)::pldim
complex(8),intent(in)::tm(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8),intent(in)::st(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
real(8),intent(in)::ev0(1_8:int(pldim,kind=8))
complex(8),intent(in)::cn(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
real(8),intent(out)::vf1(1_8:int(pldim,kind=8))
end
function band_velocity(kk,pldim,z12,cn) result(vf)
real(8),intent(in)::kk
integer(4),intent(in)::pldim
complex(8),intent(in)::z12(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8),intent(in)::cn(1_8:int(pldim,kind=8))
real(8)::vf
end
subroutine diagonalize(pldim,hh,ss,ev,cr)
integer(4)::pldim
complex(8)::hh(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
complex(8)::ss(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
real(8)::ev(1_8:int(pldim,kind=8))
complex(8),optional::cr(1_8:int(pldim,kind=8),1_8:int(pldim,kind=8))
end
subroutine sort_and_normalize(sdim,kz,vf,cr,summary)
integer(4),intent(in)::sdim
complex(8)::kz(1_8:int(sdim,kind=8))
real(8)::vf(1_8:int(sdim,kind=8))
complex(8)::cr(1_8:int(sdim,kind=8),1_8:int(sdim,kind=8))
type(tstatessummary),optional::summary
end
end
