﻿!mod$ v1 sum:8f7c60c1a1ccbd4f
!need$ 795922591f89c8ee n ln_precision
module skit_formats
use ln_precision,only:sp
use ln_precision,only:dp
use ln_precision,only:eps
use ln_precision,only:eps10
use ln_precision,only:eps12
use ln_precision,only:eps15
use ln_precision,only:sgfacc
use ln_precision,only:long
use ln_precision,only:get_machine_prec
use ln_precision,only:set_drop
private::sp
private::dp
private::eps
private::eps10
private::eps12
private::eps15
private::sgfacc
private::long
private::get_machine_prec
private::set_drop
private::rdnscsr
private::zdnscsr
private::rcsrdns
private::zcsrdns
private::rcoocsr
private::zcoocsr
private::rcsrcoo
private::zcsrcoo
private::rcsrcsc
private::zcsrcsc
private::rcsrcsc2
private::zcsrcsc2
private::rsubmat
private::zsubmat
interface dnscsr
procedure::rdnscsr
procedure::zdnscsr
end interface
interface csrdns
procedure::rcsrdns
procedure::zcsrdns
end interface
interface coocsr
procedure::rcoocsr
procedure::zcoocsr
end interface
interface csrcoo
procedure::rcsrcoo
procedure::zcsrcoo
end interface
interface csrcsc
procedure::rcsrcsc
procedure::zcsrcsc
end interface
interface csrcsc2
procedure::rcsrcsc2
procedure::zcsrcsc2
end interface
interface submat
procedure::rsubmat
procedure::zsubmat
end interface
contains
subroutine rdnscsr(nrow,ncol,nzmax,dns,a,ja,ia,ierr)
integer(4),intent(in)::nrow
integer(4),intent(in)::ncol
integer(4),intent(in)::nzmax
real(8),intent(in)::dns(:,:)
real(8),intent(inout)::a(:)
integer(4),intent(inout)::ja(:)
integer(4),intent(inout)::ia(:)
integer(4),intent(out)::ierr
end
subroutine zdnscsr(nrow,ncol,nzmax,dns,a,ja,ia,ierr)
integer(4),intent(in)::nrow
integer(4),intent(in)::ncol
integer(4),intent(in)::nzmax
complex(8),intent(in)::dns(:,:)
complex(8),intent(inout)::a(:)
integer(4),intent(inout)::ja(:)
integer(4),intent(inout)::ia(:)
integer(4),intent(out)::ierr
end
subroutine rcsrdns(nrow,ncol,a,ja,ia,dns,ierr)
integer(4),intent(in)::nrow
integer(4),intent(in)::ncol
real(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
real(8),intent(inout)::dns(:,:)
integer(4),intent(out)::ierr
end
subroutine zcsrdns(nrow,ncol,a,ja,ia,dns,ierr)
integer(4),intent(in)::nrow
integer(4),intent(in)::ncol
complex(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
complex(8),intent(inout)::dns(:,:)
integer(4),intent(out)::ierr
end
subroutine rcoocsr(nrow,nnz,a,ir,jc,ao,jao,iao)
integer(4),intent(in)::nrow
integer(4),intent(in)::nnz
real(8),intent(in)::a(:)
integer(4),intent(in)::ir(:)
integer(4),intent(in)::jc(:)
real(8),intent(inout)::ao(:)
integer(4),intent(inout)::jao(:)
integer(4),intent(inout)::iao(:)
end
subroutine zcoocsr(nrow,nnz,a,ir,jc,ao,jao,iao)
integer(4),intent(in)::nrow
integer(4),intent(in)::nnz
complex(8),intent(in)::a(:)
integer(4),intent(in)::ir(:)
integer(4),intent(in)::jc(:)
complex(8),intent(inout)::ao(:)
integer(4),intent(inout)::jao(:)
integer(4),intent(inout)::iao(:)
end
subroutine rcsrcoo(nrow,job,nzmax,a,ja,ia,nnz,ao,ir,jc,ierr)
integer(4),intent(in)::nrow
integer(4),intent(in)::job
integer(4),intent(in)::nzmax
real(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(out)::nnz
real(8),intent(inout)::ao(:)
integer(4),intent(inout)::ir(:)
integer(4),intent(inout)::jc(:)
integer(4),intent(out)::ierr
end
subroutine zcsrcoo(nrow,job,nzmax,a,ja,ia,nnz,ao,ir,jc,ierr)
integer(4),intent(in)::nrow
integer(4),intent(in)::job
integer(4),intent(in)::nzmax
complex(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(out)::nnz
complex(8),intent(inout)::ao(:)
integer(4),intent(inout)::ir(:)
integer(4),intent(inout)::jc(:)
integer(4),intent(out)::ierr
end
subroutine rcsrcsc(n,job,ipos,a,ja,ia,ao,jao,iao)
integer(4),intent(in)::n
integer(4),intent(in)::job
integer(4),intent(in)::ipos
real(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
real(8),intent(inout)::ao(:)
integer(4),intent(inout)::jao(:)
integer(4),intent(inout)::iao(:)
end
subroutine zcsrcsc(n,job,ipos,a,ja,ia,ao,jao,iao)
integer(4),intent(in)::n
integer(4),intent(in)::job
integer(4),intent(in)::ipos
complex(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
complex(8),intent(inout)::ao(:)
integer(4),intent(inout)::jao(:)
integer(4),intent(inout)::iao(:)
end
subroutine rcsrcsc2(n,n2,job,ipos,a,ja,ia,ao,jao,iao)
integer(4),intent(in)::n
integer(4),intent(in)::n2
integer(4),intent(in)::job
integer(4),intent(in)::ipos
real(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
real(8),intent(inout)::ao(:)
integer(4),intent(inout)::jao(:)
integer(4),intent(inout)::iao(:)
end
subroutine zcsrcsc2(n,n2,job,ipos,a,ja,ia,ao,jao,iao)
integer(4),intent(in)::n
integer(4),intent(in)::n2
integer(4),intent(in)::job
integer(4),intent(in)::ipos
complex(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
complex(8),intent(inout)::ao(:)
integer(4),intent(inout)::jao(:)
integer(4),intent(inout)::iao(:)
end
subroutine rsubmat(n,job,i1,i2,j1,j2,a,ja,ia,nr,nc,ao,jao,iao)
integer(4),intent(in)::n
integer(4),intent(in)::job
integer(4),intent(in)::i1
integer(4),intent(in)::i2
integer(4),intent(in)::j1
integer(4),intent(in)::j2
real(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(out)::nr
integer(4),intent(out)::nc
real(8),intent(inout)::ao(:)
integer(4),intent(inout)::jao(:)
integer(4),intent(inout)::iao(:)
end
subroutine zsubmat(n,job,i1,i2,j1,j2,a,ja,ia,nr,nc,ao,jao,iao)
integer(4),intent(in)::n
integer(4),intent(in)::job
integer(4),intent(in)::i1
integer(4),intent(in)::i2
integer(4),intent(in)::j1
integer(4),intent(in)::j2
complex(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(out)::nr
integer(4),intent(out)::nc
complex(8),intent(inout)::ao(:)
integer(4),intent(inout)::jao(:)
integer(4),intent(inout)::iao(:)
end
end
