﻿!mod$ v1 sum:0c027b8350d817fc
!need$ 795922591f89c8ee n ln_precision
module skit_unary
use ln_precision,only:sp
use ln_precision,only:dp
use ln_precision,only:eps
use ln_precision,only:eps10
use ln_precision,only:eps12
use ln_precision,only:eps15
use ln_precision,only:sgfacc
use ln_precision,only:long
use ln_precision,only:get_machine_prec
use ln_precision,only:set_drop
private::sp
private::dp
private::eps
private::eps10
private::eps12
private::eps15
private::sgfacc
private::long
private::get_machine_prec
private::set_drop
private::rgetelm
private::zgetelm
private::rgetdia
private::zgetdia
private::rtransp
private::ztransp
private::rcsort
private::zcsort
private::ivperm
private::rvperm
private::zvperm
private::ramask
private::zamask
interface getelm
procedure::rgetelm
procedure::zgetelm
end interface
interface csort
procedure::rcsort
procedure::zcsort
end interface
interface vperm
procedure::ivperm
procedure::rvperm
procedure::zvperm
end interface
private::vperm
interface transp
procedure::rtransp
procedure::ztransp
end interface
interface getdia
procedure::rgetdia
procedure::zgetdia
end interface
interface amask
procedure::ramask
procedure::zamask
end interface
contains
function rgetelm(i,j,a,ja,ia,iadd,sorted) result(getelm)
integer(4),intent(in)::i
integer(4),intent(in)::j
real(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(inout)::iadd
logical(4),intent(in)::sorted
real(8)::getelm
end
function zgetelm(i,j,a,ja,ia,iadd,sorted) result(getelm)
integer(4),intent(in)::i
integer(4),intent(in)::j
complex(8),intent(in)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(inout)::iadd
logical(4),intent(in)::sorted
complex(8)::getelm
end
subroutine rgetdia(nrow,ncol,job,a,ja,ia,len,diag,idiag,ioff)
integer(4),intent(in)::nrow
integer(4),intent(in)::ncol
integer(4),intent(in)::job
real(8),intent(inout)::a(:)
integer(4),intent(inout)::ja(:)
integer(4),intent(inout)::ia(:)
integer(4),intent(out)::len
real(8),intent(inout)::diag(:)
integer(4),intent(inout)::idiag(:)
integer(4),intent(in)::ioff
end
subroutine zgetdia(nrow,ncol,job,a,ja,ia,len,diag,idiag,ioff)
integer(4),intent(in)::nrow
integer(4),intent(in)::ncol
integer(4),intent(in)::job
complex(8),intent(inout)::a(:)
integer(4),intent(inout)::ja(:)
integer(4),intent(inout)::ia(:)
integer(4),intent(out)::len
complex(8),intent(inout)::diag(:)
integer(4),intent(inout)::idiag(:)
integer(4),intent(in)::ioff
end
subroutine rtransp(nrow,ncol,a,ja,ia,iwk,ierr)
integer(4),intent(in)::nrow
integer(4),intent(out)::ncol
real(8),intent(inout)::a(:)
integer(4),intent(inout)::ja(:)
integer(4),intent(inout)::ia(:)
integer(4),intent(inout)::iwk(:)
integer(4),intent(out)::ierr
end
subroutine ztransp(nrow,ncol,a,ja,ia,iwk,ierr)
integer(4),intent(in)::nrow
integer(4),intent(out)::ncol
complex(8),intent(inout)::a(:)
integer(4),intent(inout)::ja(:)
integer(4),intent(inout)::ia(:)
integer(4),intent(inout)::iwk(:)
integer(4),intent(out)::ierr
end
subroutine rcsort(nrow,a,ja,ia,iwork,values)
integer(4),intent(in)::nrow
real(8),intent(inout)::a(:)
integer(4),intent(inout)::ja(:)
integer(4),intent(inout)::ia(:)
integer(4),intent(inout)::iwork(:)
logical(4),intent(in)::values
end
subroutine zcsort(nrow,a,ja,ia,iwork,values)
integer(4),intent(in)::nrow
complex(8),intent(inout)::a(:)
integer(4),intent(inout)::ja(:)
integer(4),intent(inout)::ia(:)
integer(4),intent(inout)::iwork(:)
logical(4),intent(in)::values
end
subroutine ivperm(n,ix,perm)
integer(4),intent(in)::n
integer(4),intent(inout)::ix(1_8:int(n,kind=8))
integer(4),intent(inout)::perm(1_8:int(n,kind=8))
end
subroutine rvperm(n,x,perm)
integer(4),intent(in)::n
real(8),intent(inout)::x(1_8:int(n,kind=8))
integer(4),intent(inout)::perm(1_8:int(n,kind=8))
end
subroutine zvperm(n,x,perm)
integer(4),intent(in)::n
complex(8),intent(inout)::x(1_8:int(n,kind=8))
integer(4),intent(inout)::perm(1_8:int(n,kind=8))
end
subroutine bandwidth(n,ja,ia,ml,mu,iband,bndav)
integer(4),intent(in)::n
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(out)::ml
integer(4),intent(out)::mu
integer(4),intent(out)::iband
real(8),intent(out)::bndav
end
subroutine ramask(nrow,ncol,a,ja,ia,jmask,imask,c,jc,ic,iw,nzmax,ierr)
integer(4),intent(in)::nrow
integer(4),intent(in)::ncol
real(8)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(in)::jmask(:)
integer(4),intent(inout)::imask(:)
real(8)::c(:)
integer(4),intent(inout)::jc(:)
integer(4),intent(inout)::ic(:)
logical(4)::iw(:)
integer(4),intent(in)::nzmax
integer(4),intent(out)::ierr
end
subroutine zamask(nrow,ncol,a,ja,ia,jmask,imask,c,jc,ic,iw,nzmax,ierr)
integer(4),intent(in)::nrow
integer(4),intent(in)::ncol
complex(8)::a(:)
integer(4),intent(in)::ja(:)
integer(4),intent(in)::ia(:)
integer(4),intent(in)::jmask(:)
integer(4),intent(inout)::imask(:)
complex(8)::c(:)
integer(4),intent(inout)::jc(:)
integer(4),intent(inout)::ic(:)
logical(4)::iw(:)
integer(4),intent(in)::nzmax
integer(4),intent(out)::ierr
end
end
